classdef ChannelsFigure < ws.MCOSFigure
    properties  % protected by gentleman's agreement
        DeviceNamePopupLabelText
        DeviceNamePopup
        
        AIsPanel
        AIChannelNameColTitleText
        AITerminalNameColTitleText
        AIUnitsColTitleText
        AIScaleColTitleText
        AIIsActiveColTitleText        
        AIIsMarkedForDeletionColTitleText        
        AIChannelNameEdits
        AITerminalNamePopups        
        AIUnitsEdits
        AIScaleEdits
        AIScaleUnitsTexts
        AIIsActiveCheckboxes
        AIIsMarkedForDeletionCheckboxes
        AddAIChannelButton
        DeleteAIChannelsButton
        
        AOsPanel
        AOChannelNameColTitleText
        AOTerminalNameColTitleText
        AOUnitsColTitleText
        AOScaleColTitleText
        AOIsActiveColTitleText        
        AOIsMarkedForDeletionColTitleText        
        AOChannelNameEdits
        AOTerminalNamePopups        
        AOUnitsEdits
        AOScaleEdits
        AOScaleUnitsTexts
        %AOIsActiveCheckboxes
        AOIsMarkedForDeletionCheckboxes
        AddAOChannelButton
        DeleteAOChannelsButton

        DIsPanel
        DIChannelNameColTitleText
        DITerminalNameColTitleText
        DIIsActiveColTitleText        
        DIIsMarkedForDeletionColTitleText        
        DIChannelNameEdits
        DITerminalNamePopups        
        DIIsActiveCheckboxes
        DIIsMarkedForDeletionCheckboxes
        AddDIChannelButton
        DeleteDIChannelsButton
        
        DOsPanel
        DOChannelNameColTitleText
        DOTerminalNameColTitleText
        DOIsTimedColTitleText        
        DOIsOnColTitleText        
        DOIsMarkedForDeletionColTitleText        
        DOChannelNameEdits
        DOTerminalNamePopups        
        DOIsTimedCheckboxes
        DOIsOnRadiobuttons            
        DOIsMarkedForDeletionCheckboxes
        AddDOChannelButton
        DeleteDOChannelsButton
        
%         DOsPanel
%         DOIsTimedColTitleText        
%         DOIsOnColTitleText        
%         DOLabelTexts
%         DOIsTimedCheckboxes
%         DOIsOnRadiobuttons            
    end  % properties
    
    methods
        function self=ChannelsFigure(model,controller)
            self = self@ws.MCOSFigure(model,controller);
            
            % Set the relevant properties of the figure itself
            set(self.FigureGH,'Tag','ChannelsFigure', ...
                              'Units','pixels', ...
                              'Resize','off', ...
                              'Name','Device & Channels...', ...
                              'NumberTitle','off', ...
                              'Menubar','none', ...
                              'Visible','off');
            
            % Create all the "static" controls, set them up, but don't position them
            self.createFixedControls_();

            % Set up the tags of the HG objects to match the property names
            %self.updateHGObjectTags_();
           
            % Initialize the guidata
            %self.updateGuidata_();

            % sync up self to model
            self.update();         
            
            % Subscribe to model events
            model=self.Model;  % this is the root model
            if ~isempty(model) ,
                model.subscribeMe(self,'Update','','update');                
                model.subscribeMe(self,'DidSetState','','updateControlProperties');
                model.subscribeMe(self,'UpdateChannels','','update');         
                model.subscribeMe(self,'UpdateDigitalOutputStateIfUntimed','','updateControlProperties');
%                 acquisition=model.Acquisition;
%                 if ~isempty(acquisition) ,
%                     %acquisition.subscribeMe(self,'DidChangeNumberOfChannels','','update');
%                     %acquisition.subscribeMe(self,'DidSetAnalogChannelUnitsOrScales','','updateControlProperties');
%                     %acquisition.subscribeMe(self,'DidSetIsChannelActive','','updateControlProperties');
%                 end
%                 stimulation=model.Stimulation;
%                 if ~isempty(stimulation) ,
%                     %stimulation.subscribeMe(self,'DidChangeNumberOfChannels','','update');
%                     %stimulation.subscribeMe(self,'DidSetAnalogChannelUnitsOrScales','','updateControlProperties');                    
%                     %stimulation.subscribeMe(self,'DidSetIsDigitalChannelTimed','','update');               
%                     %stimulation.subscribeMe(self,'DidSetDigitalOutputStateIfUntimed','','updateControlProperties');               
%                 end
            end
            
            % make the figure visible
            set(self.FigureGH,'Visible','on');                        
        end

%         function value=maximumAILabelTextWidth(self)
%             n=length(self.AILabelTexts);
%             value=-inf;
%             for i=1:n ,
%                 thisExtent=get(self.AILabelTexts(i),'Extent');
%                 thisWidth=thisExtent(3);
%                 value=max(value,thisWidth);
%             end            
%         end
        
%         function value=maximumAOLabelTextWidth(self)
%             n=length(self.AOLabelTexts);            
%             value=-inf;
%             for i=1:n ,
%                 thisExtent=get(self.AOLabelTexts(i),'Extent');
%                 thisWidth=thisExtent(3);
%                 value=max(value,thisWidth);
%             end            
%         end
%         
%         function value=maximumDILabelTextWidth(self)
%             n=length(self.DILabelTexts);
%             value=-inf;
%             for i=1:n ,
%                 thisExtent=get(self.DILabelTexts(i),'Extent');
%                 thisWidth=thisExtent(3);
%                 value=max(value,thisWidth);
%             end            
%         end
%         
%         function value=maximumDOLabelTextWidth(self)
%             n=length(self.DOLabelTexts);            
%             value=-inf;
%             for i=1:n ,
%                 thisExtent=get(self.DOLabelTexts(i),'Extent');
%                 thisWidth=thisExtent(3);
%                 value=max(value,thisWidth);
%             end            
%         end
    end  % public methods block
        
    methods (Access=protected)
        function createFixedControls_(self)
            % Create the device name popup and label
            self.DeviceNamePopupLabelText = ...
                ws.uicontrol('Parent',self.FigureGH, ...
                          'Style','text', ...
                          'HorizontalAlignment','right', ...
                          'String','Device:');
            self.DeviceNamePopup = ...
                ws.uicontrol('Parent',self.FigureGH, ...
                          'Style','popup', ...
                          'BackgroundColor','w', ...
                          'HorizontalAlignment','left', ...
                          'Callback',@(source,event)(self.controlActuated('DeviceNamePopup',source,event)) );
            
            % Create the panels and the fixed controls in them
            self.createAIPanelFixedControls_() ;
            self.createAOPanelFixedControls_() ;
            self.createDIPanelFixedControls_() ;
            self.createDOPanelFixedControls_() ;
        end  % method
        
        function createAIPanelFixedControls_(self)
            % Make the panel itself
            self.AIsPanel= ...
                ws.uipanel('Parent',self.FigureGH, ...
                        'Tag','AIsPanel', ...
                        'Title','AI Channels');
            
            % make the title row
            self.AIChannelNameColTitleText = ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Name');
            self.AITerminalNameColTitleText = ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Terminal');
            self.AIUnitsColTitleText= ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','text', ...                          
                          'HorizontalAlignment','center', ...
                          'String','Units');
            self.AIScaleColTitleText= ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Scale');
            self.AIIsActiveColTitleText= ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Active?');
            self.AIIsMarkedForDeletionColTitleText= ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Delete?');
                    
            % make the buttons
            self.AddAIChannelButton= ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','pushbutton', ...
                          'String','Add', ...
                          'Callback',@(source,event)(self.controlActuated('AddAIChannelButton',source,event)) );
            self.DeleteAIChannelsButton= ...
                ws.uicontrol('Parent',self.AIsPanel, ...
                          'Style','pushbutton', ...
                          'String','Delete', ...
                          'Callback',@(source,event)(self.controlActuated('DeleteAIChannelsButton',source,event)) );
        end  % method
        
        function createAOPanelFixedControls_(self)
            % Make the panel itself
            self.AOsPanel= ...
                ws.uipanel('Parent',self.FigureGH, ...
                        'Tag','AOsPanel', ...
                        'Title','AO Channels');
            
            % make the title row
            self.AOChannelNameColTitleText = ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Name');
            self.AOTerminalNameColTitleText = ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Terminal');
            self.AOUnitsColTitleText= ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Units');
            self.AOScaleColTitleText= ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Scale');
%             self.AOIsActiveColTitleText= ...
%                 ws.uicontrol('Parent',self.AOsPanel, ...
%                           'Style','text', ...
%                           'HorizontalAlignment','center', ...
%                           'String','Active?');
            self.AOIsMarkedForDeletionColTitleText= ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Delete?');
                    
            % make the buttons
            self.AddAOChannelButton= ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','pushbutton', ...
                          'String','Add', ...
                          'Callback',@(source,event)(self.controlActuated('AddAOChannelButton',source,event)) );
            self.DeleteAOChannelsButton= ...
                ws.uicontrol('Parent',self.AOsPanel, ...
                          'Style','pushbutton', ...
                          'String','Delete', ...
                          'Callback',@(source,event)(self.controlActuated('DeleteAOChannelsButton',source,event)) );
        end  % method
        
        function createDIPanelFixedControls_(self)
            % Make the panel itself
            self.DIsPanel= ...
                ws.uipanel('Parent',self.FigureGH, ...
                        'Tag','DIsPanel', ...
                        'Title','DI Channels');
            
            % make the title row
            self.DIChannelNameColTitleText = ...
                ws.uicontrol('Parent',self.DIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Name');
            self.DITerminalNameColTitleText = ...
                ws.uicontrol('Parent',self.DIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Terminal');
            self.DIIsActiveColTitleText= ...
                ws.uicontrol('Parent',self.DIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Active?');
            self.DIIsMarkedForDeletionColTitleText= ...
                ws.uicontrol('Parent',self.DIsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Delete?');
                    
            % make the buttons
            self.AddDIChannelButton= ...
                ws.uicontrol('Parent',self.DIsPanel, ...
                          'Style','pushbutton', ...
                          'String','Add', ...
                          'Callback',@(source,event)(self.controlActuated('AddDIChannelButton',source,event)) );
            self.DeleteDIChannelsButton= ...
                ws.uicontrol('Parent',self.DIsPanel, ...
                          'Style','pushbutton', ...
                          'String','Delete', ...
                          'Callback',@(source,event)(self.controlActuated('DeleteDIChannelsButton',source,event)) );
        end  % method
        
        function createDOPanelFixedControls_(self)
            % Make the panel itself
            self.DOsPanel= ...
                ws.uipanel('Parent',self.FigureGH, ...
                        'Tag','DOsPanel', ...
                        'Title','DO Channels');
            
            % make the title row
            self.DOChannelNameColTitleText = ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Name');
            self.DOTerminalNameColTitleText = ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Terminal');
            self.DOIsTimedColTitleText= ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Timed?');
            self.DOIsOnColTitleText= ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','On?');
            self.DOIsMarkedForDeletionColTitleText= ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','text', ...
                          'HorizontalAlignment','center', ...
                          'String','Delete?');
                    
            % make the buttons
            self.AddDOChannelButton= ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','pushbutton', ...
                          'String','Add', ...
                          'Callback',@(source,event)(self.controlActuated('AddDOChannelButton',source,event)) );
            self.DeleteDOChannelsButton= ...
                ws.uicontrol('Parent',self.DOsPanel, ...
                          'Style','pushbutton', ...
                          'String','Delete', ...
                          'Callback',@(source,event)(self.controlActuated('DeleteDOChannelsButton',source,event)) );
        end  % method
        
        function layout_(self)
            % Layout parameters
            topAreaHeight = 60 ;
            deviceNamePopupXOffset = 66 ;
            deviceNamePopupWidth = 100 ;
            %deviceNamePopupHeight = 16 ;
            panelBorderSize=6;  % this is the space between the panel borders and the figure border on the left, right, and bottom
            interPanelSpaceWidth=10;
            interPanelSpaceHeight=10;
            panelToTitleRowSpaceHeight=28;  % need to accomodate the panel title, plus a bit more to make it look nice
            buttonsToFrameSpaceHeight=8;
            titleRowHeight=10;
            rowHeight=16;
            interRowHeight=10;
            %rowToRowHeight=rowHeight+interRowHeight;
            panelToChannelNameColSpaceWidth=5;
            channelNameEditWidth = 100 ;
            terminalNamePopupWidth = 52 ;
            spaceBetweenChannelNameAndTerminalNameWidth = 14 ;
            %diLabelWidthWanted=max(30,self.maximumDILabelTextWidth());
            %aiLabelWidthWanted=max(30,self.maximumAILabelTextWidth());
            %inputLabelWidth=max(diLabelWidthWanted,aiLabelWidthWanted);
            %inputLabelWidth = channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth + aiTerminalNamePopupWidth ;
            %aiLabelWidth=inputLabelWidth;            
            editShimHeight=5;
            editHeight=rowHeight+editShimHeight;  % shim makes it look nicer
            scaleEditWidth=42;
            scaleUnitsTextWidth = 36 ;
            unitsEditWidth=25;
            labelHeight=rowHeight;
            withinPanelRightPadWidth = 4 ;
            %aiPanelRightPadWidth = withinPanelRightPadWidth ;
            spaceBetweenTerminalAndRestWidth=14;
            spaceBetweenUnitsAndScaleWidth = 12 ;
            spaceBetweenScaleAndScaleUnitsWidth=2;
            %interUnitsSpaceWidth=0;            
            %doLabelWidthWanted=max(30,self.maximumDOLabelTextWidth());            
            %aoLabelWidthWanted=max(30,self.maximumAOLabelTextWidth());
            %outputLabelWidth=max(doLabelWidthWanted,aoLabelWidthWanted);            
            %outputLabelWidth = channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth + terminalNamePopupWidth ;
            %aoLabelWidth=outputLabelWidth;            
            %aoUnitsDenominatorTextWidth=12;
            spaceBetweenScaleUnitsAndCheckboxColsWidth=8;
            isActiveColWidth=46;
            spaceBeforeIsMarkedForDeletionColWidth=0;
            isMarkedForDeletionColWidth=46;
            spaceBelowTitleRowHeight=2;
            %spaceBeforeAOMultiplierColWidth=0;
            %aoMultiplierEditWidth=0;
            buttonHeight = 20 ;
            addButtonWidth = 46 ;
            deleteButtonWidth = 70 ;
            spaceBetweenRowsAndButtonsHeight = 14 ;
            spaceBetweenButtonsWidth = 8 ;
            extraSpaceFromDeleteButtonToBorder = 4 ;
            isTimedColWidth = 46 ;
            isOnColWidth = 46 ;
            
            % Derived layout parameters
            nAIs=length(self.AIChannelNameEdits);
            nAOs=length(self.AOChannelNameEdits);            
            nDIs=length(self.DIChannelNameEdits);            
            nDOs=length(self.DOChannelNameEdits);            
            nAnalogRows=max(nAIs,nAOs);
            nDigitalRows=max(nDIs,nDOs);
            %aoUnitsEditWidth=unitsEditWidth;
            %aoPanelRightPadWidth = withinPanelRightPadWidth ;
            aiPanelWidth = ...
                panelToChannelNameColSpaceWidth+...
                channelNameEditWidth + ...
                spaceBetweenChannelNameAndTerminalNameWidth + ...
                terminalNamePopupWidth + ...                
                spaceBetweenTerminalAndRestWidth+ ...
                unitsEditWidth+ ...
                spaceBetweenUnitsAndScaleWidth + ...
                scaleEditWidth+ ...
                spaceBetweenScaleAndScaleUnitsWidth+ ...
                scaleUnitsTextWidth+ ...
                spaceBetweenScaleUnitsAndCheckboxColsWidth + ...
                isActiveColWidth+ ...
                spaceBeforeIsMarkedForDeletionColWidth + ...
                isMarkedForDeletionColWidth+ ...                
                withinPanelRightPadWidth ;
            diPanelWidth = aiPanelWidth ;
            aoPanelWidth = ...
                panelToChannelNameColSpaceWidth+...
                channelNameEditWidth + ...
                spaceBetweenChannelNameAndTerminalNameWidth + ...
                terminalNamePopupWidth + ...                
                spaceBetweenTerminalAndRestWidth+ ...
                unitsEditWidth+ ...
                spaceBetweenUnitsAndScaleWidth + ...
                scaleEditWidth+ ...
                spaceBetweenScaleAndScaleUnitsWidth+ ...
                scaleUnitsTextWidth+ ...
                spaceBetweenScaleUnitsAndCheckboxColsWidth + ...
                isMarkedForDeletionColWidth+ ...                
                withinPanelRightPadWidth ;
            doPanelWidth = aoPanelWidth ;
            analogPanelsHeight = panelToTitleRowSpaceHeight + titleRowHeight + spaceBelowTitleRowHeight + ...
                                 max(0,(nAnalogRows-1))*interRowHeight + nAnalogRows*rowHeight + ...
                                 spaceBetweenRowsAndButtonsHeight + ...
                                 buttonHeight + ...
                                 buttonsToFrameSpaceHeight ;
            digitalPanelsHeight = panelToTitleRowSpaceHeight + titleRowHeight + spaceBelowTitleRowHeight + ...
                                  max(0,(nDigitalRows-1))*interRowHeight + nDigitalRows*rowHeight + ...
                                  spaceBetweenRowsAndButtonsHeight + ...
                                  buttonHeight + ...
                                  buttonsToFrameSpaceHeight ;
            figureHeight = topAreaHeight + analogPanelsHeight + interPanelSpaceHeight + digitalPanelsHeight + panelBorderSize ;
            figureWidth = panelBorderSize + aiPanelWidth + interPanelSpaceWidth + aoPanelWidth + panelBorderSize ;
            
            % Position the figure, keeping upper left corner fixed
            currentPosition=get(self.FigureGH,'Position');
            currentOffset=currentPosition(1:2);
            currentSize=currentPosition(3:4);
            currentUpperY=currentOffset(2)+currentSize(2);
            figurePosition=[currentOffset(1) currentUpperY-figureHeight figureWidth figureHeight];
            set(self.FigureGH,'Position',figurePosition);
            
            % Position the device name popup in the middle (vertically) of
            % the top area, at the given x offset.
            popupPosition = get(self.DeviceNamePopup, 'Position') ;
            popupHeight = popupPosition(4) ;
            deviceNamePopupYOffset = figureHeight - topAreaHeight + (topAreaHeight - popupHeight) /2 ;
            ws.positionPopupmenuAndLabelBang(self.DeviceNamePopupLabelText,self.DeviceNamePopup, ...
                                                     deviceNamePopupXOffset,deviceNamePopupYOffset,deviceNamePopupWidth) ;
            
            % Position the AIs panel, and layout its contents
            self.layoutAIPanel_(panelBorderSize, ...
                                aiPanelWidth, ...
                                interPanelSpaceHeight, ...                                
                                analogPanelsHeight, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                spaceBetweenTerminalAndRestWidth, ...
                                channelNameEditWidth, ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                scaleEditWidth, ...
                                spaceBetweenScaleAndScaleUnitsWidth, ...
                                scaleUnitsTextWidth, ...
                                unitsEditWidth, ...
                                spaceBetweenScaleUnitsAndCheckboxColsWidth, ...
                                isActiveColWidth, ...
                                spaceBeforeIsMarkedForDeletionColWidth, ...
                                isMarkedForDeletionColWidth, ...                                
                                labelHeight, ...
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                spaceBetweenUnitsAndScaleWidth) ;
                            
            % Position and layout the AOs panel
            self.layoutAOPanel_(panelBorderSize, ...
                                aiPanelWidth, ...
                                aoPanelWidth, ...
                                interPanelSpaceWidth, ...                                                                
                                interPanelSpaceHeight, ...                                
                                analogPanelsHeight, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                spaceBetweenTerminalAndRestWidth, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                scaleEditWidth, ...
                                spaceBetweenScaleAndScaleUnitsWidth, ...
                                scaleUnitsTextWidth, ...
                                unitsEditWidth, ...
                                spaceBetweenScaleUnitsAndCheckboxColsWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                labelHeight, ...
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                spaceBetweenUnitsAndScaleWidth) ;
            
            % Position and layout the DIs panel
            self.layoutDIPanel_(panelBorderSize, ...
                                aiPanelWidth, ...
                                diPanelWidth, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                spaceBetweenTerminalAndRestWidth, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                scaleEditWidth, ...
                                spaceBetweenScaleAndScaleUnitsWidth, ...
                                scaleUnitsTextWidth, ...
                                unitsEditWidth, ...
                                spaceBetweenScaleUnitsAndCheckboxColsWidth, ...
                                isActiveColWidth, ...
                                spaceBeforeIsMarkedForDeletionColWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                labelHeight, ...
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                spaceBetweenUnitsAndScaleWidth) ;
            
            % Position and layout the DO panel
            self.layoutDOPanel_(panelBorderSize, ...
                                interPanelSpaceWidth , ...
                                aiPanelWidth, ...
                                doPanelWidth, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                isTimedColWidth, ...
                                isOnColWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                withinPanelRightPadWidth )
            
%             
%             self.layoutDOPanel_(panelBorderSize, ...
%                                 aiPanelWidth, ...
%                                 interPanelSpaceWidth, ...
%                                 aoPanelWidth, ...
%                                 digitalPanelsHeight, ...
%                                 panelToTitleRowSpaceHeight, ...
%                                 titleRowHeight, ...
%                                 panelToChannelNameColSpaceWidth, ...
%                                 spaceBelowTitleRowHeight, ...
%                                 rowHeight, ...
%                                 interRowHeight, ...
%                                 outputLabelWidth, ...
%                                 spaceBetweenTerminalAndRestWidth, ...                                
%                                 scaleAndUnitsControlsWidth);
        end  % method
    
        function layoutAIPanel_(self, ...
                                panelBorderSize, ...
                                aiPanelWidth, ...
                                interPanelSpaceHeight, ...                                
                                analogPanelsHeight, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                spaceBetweenTerminalAndRestWidth, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                scaleEditWidth, ...
                                spaceBetweenScaleAndScaleUnitsWidth, ...
                                scaleUnitsTextWidth, ...
                                unitsEditWidth, ...
                                spaceBetweenScaleUnitsAndCheckboxColsWidth, ...
                                isActiveColWidth, ...
                                spaceBeforeIsMarkedForDeletionColWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                labelHeight, ...
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                spaceBetweenUnitsAndScaleWidth)
                            
            % Define constants     
            nAIs = length(self.AIChannelNameEdits) ;            
            rowToRowHeight=rowHeight+interRowHeight;

            % Position the AIs panel
            set(self.AIsPanel, 'Position', [panelBorderSize panelBorderSize+digitalPanelsHeight+interPanelSpaceHeight aiPanelWidth analogPanelsHeight]) ;
            
            %
            %  Layout the row of column titles in AI panel
            %
            titleRowBottomY = analogPanelsHeight - panelToTitleRowSpaceHeight - titleRowHeight ;
            
            % Channel Name
            channelNameColLeftX = panelToChannelNameColSpaceWidth ;
            ws.alignTextInRectangleBang(self.AIChannelNameColTitleText, ...
                                                [channelNameColLeftX titleRowBottomY channelNameEditWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Terminal Name                                            
            terminalNameColLeftX = channelNameColLeftX + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
            ws.alignTextInRectangleBang(self.AITerminalNameColTitleText, ...
                                                [terminalNameColLeftX titleRowBottomY terminalNamePopupWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Unit
            unitColLeftX = terminalNameColLeftX + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
            ws.alignTextInRectangleBang(self.AIUnitsColTitleText, ...
                                                [unitColLeftX titleRowBottomY unitsEditWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Scale Factor
            scaleColLeftX = unitColLeftX + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
            ws.alignTextInRectangleBang(self.AIScaleColTitleText, ...
                                                [scaleColLeftX titleRowBottomY scaleEditWidth titleRowHeight], ...
                                                'cm');
            
            % Active?                                
            isActiveColLeftX = scaleColLeftX + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth + ...
                               scaleUnitsTextWidth + ...
                               spaceBetweenScaleUnitsAndCheckboxColsWidth ;
            ws.alignTextInRectangleBang(self.AIIsActiveColTitleText, [isActiveColLeftX titleRowBottomY isActiveColWidth titleRowHeight], 'cm');
            
            % Delete?
            isMarkedForDeletionColLeftX=isActiveColLeftX + isActiveColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
            ws.alignTextInRectangleBang(self.AIIsMarkedForDeletionColTitleText, ...
                                                [isMarkedForDeletionColLeftX titleRowBottomY isMarkedForDeletionColWidth titleRowHeight], ...
                                                'cm');
            
            % Position the stuff in the AI rows            
            aiYRowBottom=titleRowBottomY-spaceBelowTitleRowHeight-rowHeight;   
            for i=1:nAIs ,
                % channel name
                xColLeft=panelToChannelNameColSpaceWidth;
                set(self.AIChannelNameEdits(i), ...
                    'Position',[xColLeft aiYRowBottom-editShimHeight channelNameEditWidth editHeight]);  % shim to make look nice
                % terminal name
                xColLeft = xColLeft + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
                set(self.AITerminalNamePopups(i), ...
                    'Position',[xColLeft aiYRowBottom terminalNamePopupWidth rowHeight]);  % shim to make look nice
                % units
                xColLeft = xColLeft + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
                set(self.AIUnitsEdits(i), ...
                    'Position',[xColLeft aiYRowBottom-editShimHeight unitsEditWidth editHeight] );
                % scale
                xColLeft = xColLeft + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
                set(self.AIScaleEdits(i), ...
                    'Position',[xColLeft aiYRowBottom-editShimHeight scaleEditWidth editHeight]);
                % scale units
                xColLeft = xColLeft + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth ;
                set(self.AIScaleUnitsTexts(i), ...
                    'Position',[xColLeft aiYRowBottom-4 scaleUnitsTextWidth labelHeight]);
                % active?
                xColLeft = xColLeft + scaleUnitsTextWidth + spaceBetweenScaleUnitsAndCheckboxColsWidth ;
                ws.centerCheckboxBang(self.AIIsActiveCheckboxes(i),[xColLeft+isActiveColWidth/2 aiYRowBottom+rowHeight/2]);
                % delete?
                xColLeft = xColLeft + isActiveColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
                ws.centerCheckboxBang(self.AIIsMarkedForDeletionCheckboxes(i),[xColLeft+isMarkedForDeletionColWidth/2 aiYRowBottom+rowHeight/2]);                
                
                % Prepare for next iteration
                aiYRowBottom=aiYRowBottom-rowToRowHeight;
            end
            
            % Position the AI Panel buttons
            buttonYOffset = buttonsToFrameSpaceHeight ;
            
            deleteButtonXOffset = aiPanelWidth - panelBorderSize - extraSpaceFromDeleteButtonToBorder - deleteButtonWidth ;  % delete button is flush right
            deleteButtonYOffset = buttonYOffset ;
            deleteButtonHeight = buttonHeight ;
            set(self.DeleteAIChannelsButton, ...
                'Position',[deleteButtonXOffset deleteButtonYOffset deleteButtonWidth deleteButtonHeight]) ;
            
            addButtonXOffset = deleteButtonXOffset - spaceBetweenButtonsWidth - addButtonWidth ;  % add button is to left of delete button
            addButtonYOffset = buttonYOffset ;
            addButtonHeight = buttonHeight ;
            set(self.AddAIChannelButton, ...
                'Position',[addButtonXOffset addButtonYOffset addButtonWidth addButtonHeight]) ;
        end  % function
        
        function layoutAOPanel_(self, ...
                                panelBorderSize, ...
                                aiPanelWidth, ...
                                aoPanelWidth, ...
                                interPanelSpaceWidth, ...                                
                                interPanelSpaceHeight, ...                                
                                analogPanelsHeight, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                spaceBetweenTerminalAndRestWidth, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                scaleEditWidth, ...
                                spaceBetweenScaleAndScaleUnitsWidth, ...
                                scaleUnitsTextWidth, ...
                                unitsEditWidth, ...
                                spaceBetweenScaleUnitsAndCheckboxColsWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                labelHeight, ...
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                spaceBetweenUnitsAndScaleWidth)
                            
            % Define constants     
            nAOs = length(self.AOChannelNameEdits) ;            
            rowToRowHeight=rowHeight+interRowHeight;
            isActiveColWidth = 0;  % This col doesn't exist for outputs
            spaceBeforeIsMarkedForDeletionColWidth = 0 ;
            
            % Position the AOs panel
            panelXOffset = panelBorderSize+aiPanelWidth+interPanelSpaceWidth ;
            panelYOffset = panelBorderSize+digitalPanelsHeight+interPanelSpaceHeight ;
            set(self.AOsPanel, 'Position', [ panelXOffset panelYOffset aoPanelWidth analogPanelsHeight]) ;
            
            %
            %  Layout the row of column titles in AO panel
            %
            titleRowBottomY = analogPanelsHeight - panelToTitleRowSpaceHeight - titleRowHeight ;
            
            % Channel Name
            channelNameColLeftX = panelToChannelNameColSpaceWidth ;
            ws.alignTextInRectangleBang(self.AOChannelNameColTitleText, ...
                                                [channelNameColLeftX titleRowBottomY channelNameEditWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Terminal Name                                            
            terminalNameColLeftX = channelNameColLeftX + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
            ws.alignTextInRectangleBang(self.AOTerminalNameColTitleText, ...
                                                [terminalNameColLeftX titleRowBottomY terminalNamePopupWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Unit
            unitColLeftX = terminalNameColLeftX + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
            ws.alignTextInRectangleBang(self.AOUnitsColTitleText, ...
                                                [unitColLeftX titleRowBottomY unitsEditWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Scale Factor
            scaleColLeftX = unitColLeftX + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
            ws.alignTextInRectangleBang(self.AOScaleColTitleText, ...
                                                [scaleColLeftX titleRowBottomY scaleEditWidth titleRowHeight], ...
                                                'cm');
            
            % Active?                                
            isActiveColLeftX = scaleColLeftX + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth + ...
                               scaleUnitsTextWidth + ...
                               spaceBetweenScaleUnitsAndCheckboxColsWidth ;
            %ws.alignTextInRectangleBang(self.AOIsActiveColTitleText, [isActiveColLeftX titleRowBottomY isActiveColWidth titleRowHeight], 'cm');
            
            % Delete?
            isMarkedForDeletionColLeftX=isActiveColLeftX + isActiveColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
            ws.alignTextInRectangleBang(self.AOIsMarkedForDeletionColTitleText, ...
                                                [isMarkedForDeletionColLeftX titleRowBottomY isMarkedForDeletionColWidth titleRowHeight], ...
                                                'cm');
            
            % Position the stuff in the AO rows            
            aiYRowBottom=titleRowBottomY-spaceBelowTitleRowHeight-rowHeight;   
            for i=1:nAOs ,
                % channel name
                xColLeft=panelToChannelNameColSpaceWidth;
                set(self.AOChannelNameEdits(i), ...
                    'Position',[xColLeft aiYRowBottom-editShimHeight channelNameEditWidth editHeight]);  % shim to make look nice
                % terminal name
                xColLeft = xColLeft + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
                set(self.AOTerminalNamePopups(i), ...
                    'Position',[xColLeft aiYRowBottom terminalNamePopupWidth rowHeight]);  % shim to make look nice
                % units
                xColLeft = xColLeft + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
                set(self.AOUnitsEdits(i), ...
                    'Position',[xColLeft aiYRowBottom-editShimHeight unitsEditWidth editHeight] );
                % scale
                xColLeft = xColLeft + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
                set(self.AOScaleEdits(i), ...
                    'Position',[xColLeft aiYRowBottom-editShimHeight scaleEditWidth editHeight]);
                % scale units
                xColLeft = xColLeft + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth ;
                set(self.AOScaleUnitsTexts(i), ...
                    'Position',[xColLeft aiYRowBottom-4 scaleUnitsTextWidth labelHeight]);
                % active?
                xColLeft = xColLeft + scaleUnitsTextWidth + spaceBetweenScaleUnitsAndCheckboxColsWidth ;
                %ws.centerCheckboxBang(self.AOIsActiveCheckboxes(i),[xColLeft+isActiveColWidth/2 aiYRowBottom+rowHeight/2]);
                % delete?
                xColLeft = xColLeft + isActiveColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
                ws.centerCheckboxBang(self.AOIsMarkedForDeletionCheckboxes(i),[xColLeft+isMarkedForDeletionColWidth/2 aiYRowBottom+rowHeight/2]);                
                
                % Prepare for next iteration
                aiYRowBottom=aiYRowBottom-rowToRowHeight;
            end
            
            % Position the AO Panel buttons
            buttonYOffset = buttonsToFrameSpaceHeight ;
            
            deleteButtonXOffset = aoPanelWidth - panelBorderSize - extraSpaceFromDeleteButtonToBorder - deleteButtonWidth ;  % delete button is flush right
            deleteButtonYOffset = buttonYOffset ;
            deleteButtonHeight = buttonHeight ;
            set(self.DeleteAOChannelsButton, ...
                'Position',[deleteButtonXOffset deleteButtonYOffset deleteButtonWidth deleteButtonHeight]) ;
            
            addButtonXOffset = deleteButtonXOffset - spaceBetweenButtonsWidth - addButtonWidth ;  % add button is to left of delete button
            addButtonYOffset = buttonYOffset ;
            addButtonHeight = buttonHeight ;
            set(self.AddAOChannelButton, ...
                'Position',[addButtonXOffset addButtonYOffset addButtonWidth addButtonHeight]) ;
        end  % function
        
        function layoutDIPanel_(self, ...
                                panelBorderSize, ...
                                aiPanelWidth, ...
                                diPanelWidth, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                spaceBetweenTerminalAndRestWidth, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                scaleEditWidth, ...
                                spaceBetweenScaleAndScaleUnitsWidth, ...
                                scaleUnitsTextWidth, ...
                                unitsEditWidth, ...
                                spaceBetweenScaleUnitsAndCheckboxColsWidth, ...
                                isActiveColWidth, ...
                                spaceBeforeIsMarkedForDeletionColWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                labelHeight, ...
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                spaceBetweenUnitsAndScaleWidth)  %#ok<INUSL>
                            
            % Define constants     
            nDIs = length(self.DIChannelNameEdits) ;            
            rowToRowHeight = rowHeight + interRowHeight ;

            % Position the DIs panel
            set(self.DIsPanel, 'Position', [panelBorderSize panelBorderSize aiPanelWidth digitalPanelsHeight]) ;
            
            %
            %  Layout the row of column titles in DI panel
            %
            titleRowBottomY = digitalPanelsHeight - panelToTitleRowSpaceHeight - titleRowHeight ;
            
            % Channel Name
            channelNameColLeftX = panelToChannelNameColSpaceWidth ;
            ws.alignTextInRectangleBang(self.DIChannelNameColTitleText, ...
                                                [channelNameColLeftX titleRowBottomY channelNameEditWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Terminal Name                                            
            terminalNameColLeftX = channelNameColLeftX + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
            ws.alignTextInRectangleBang(self.DITerminalNameColTitleText, ...
                                                [terminalNameColLeftX titleRowBottomY terminalNamePopupWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Unit
            unitColLeftX = terminalNameColLeftX + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
%             ws.alignTextInRectangleBang(self.DIUnitsColTitleText, ...
%                                                 [unitColLeftX titleRowBottomY unitsEditWidth titleRowHeight], ...
%                                                 'cm');
            
            % Channel Scale Factor
            scaleColLeftX = unitColLeftX + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
%             ws.alignTextInRectangleBang(self.DIScaleColTitleText, ...
%                                                 [scaleColLeftX titleRowBottomY scaleEditWidth titleRowHeight], ...
%                                                 'cm');
            
            % Active?                                
            isActiveColLeftX = scaleColLeftX + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth + ...
                               scaleUnitsTextWidth + ...
                               spaceBetweenScaleUnitsAndCheckboxColsWidth ;
            ws.alignTextInRectangleBang(self.DIIsActiveColTitleText, [isActiveColLeftX titleRowBottomY isActiveColWidth titleRowHeight], 'cm');
            
            % Delete?
            isMarkedForDeletionColLeftX=isActiveColLeftX + isActiveColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
            ws.alignTextInRectangleBang(self.DIIsMarkedForDeletionColTitleText, ...
                                                [isMarkedForDeletionColLeftX titleRowBottomY isMarkedForDeletionColWidth titleRowHeight], ...
                                                'cm');
            
            % Position the stuff in the DI rows            
            yRowBottom=titleRowBottomY-spaceBelowTitleRowHeight-rowHeight;   
            for i=1:nDIs ,
                % channel name
                xColLeft=panelToChannelNameColSpaceWidth;
                set(self.DIChannelNameEdits(i), ...
                    'Position',[xColLeft yRowBottom-editShimHeight channelNameEditWidth editHeight]);  % shim to make look nice
                % terminal name
                xColLeft = xColLeft + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
                set(self.DITerminalNamePopups(i), ...
                    'Position',[xColLeft yRowBottom terminalNamePopupWidth rowHeight]);  % shim to make look nice
                % units
                xColLeft = xColLeft + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
                %set(self.DIUnitsEdits(i), ...
                %    'Position',[xColLeft diYRowBottom-editShimHeight unitsEditWidth editHeight] );
                % scale
                xColLeft = xColLeft + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
                %set(self.DIScaleEdits(i), ...
                %    'Position',[xColLeft diYRowBottom-editShimHeight scaleEditWidth editHeight]);
                % scale units
                xColLeft = xColLeft + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth ;
                %set(self.DIScaleUnitsTexts(i), ...
                %    'Position',[xColLeft diYRowBottom-4 scaleUnitsTextWidth labelHeight]);
                % active?
                xColLeft = xColLeft + scaleUnitsTextWidth + spaceBetweenScaleUnitsAndCheckboxColsWidth ;
                ws.centerCheckboxBang(self.DIIsActiveCheckboxes(i),[xColLeft+isActiveColWidth/2 yRowBottom+rowHeight/2]);
                % delete?
                xColLeft = xColLeft + isActiveColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
                ws.centerCheckboxBang(self.DIIsMarkedForDeletionCheckboxes(i),[xColLeft+isMarkedForDeletionColWidth/2 yRowBottom+rowHeight/2]);                
                
                % Prepare for next iteration
                yRowBottom=yRowBottom-rowToRowHeight;
            end
            
            % Position the DI Panel buttons
            buttonYOffset = buttonsToFrameSpaceHeight ;
            
            deleteButtonXOffset = diPanelWidth - panelBorderSize - extraSpaceFromDeleteButtonToBorder - deleteButtonWidth ;  % delete button is flush right
            deleteButtonYOffset = buttonYOffset ;
            deleteButtonHeight = buttonHeight ;
            set(self.DeleteDIChannelsButton, ...
                'Position',[deleteButtonXOffset deleteButtonYOffset deleteButtonWidth deleteButtonHeight]) ;
            
            addButtonXOffset = deleteButtonXOffset - spaceBetweenButtonsWidth - addButtonWidth ;  % add button is to left of delete button
            addButtonYOffset = buttonYOffset ;
            addButtonHeight = buttonHeight ;
            set(self.AddDIChannelButton, ...
                'Position',[addButtonXOffset addButtonYOffset addButtonWidth addButtonHeight]) ;
        end  % function
        
        function layoutDOPanel_(self, ...
                                panelBorderSize, ...
                                interPanelSpaceWidth , ...
                                aiPanelWidth, ...
                                doPanelWidth, ...
                                digitalPanelsHeight, ...
                                panelToTitleRowSpaceHeight, ...
                                titleRowHeight, ...
                                panelToChannelNameColSpaceWidth, ...
                                spaceBelowTitleRowHeight, ...
                                rowHeight, ...
                                interRowHeight, ...
                                channelNameEditWidth , ...
                                spaceBetweenChannelNameAndTerminalNameWidth, ...
                                terminalNamePopupWidth , ...
                                isTimedColWidth, ...
                                isOnColWidth, ...
                                isMarkedForDeletionColWidth, ...                                                                
                                editHeight, ...
                                editShimHeight, ...
                                extraSpaceFromDeleteButtonToBorder, ...
                                buttonsToFrameSpaceHeight, ...
                                deleteButtonWidth, ...
                                spaceBetweenButtonsWidth, ...
                                addButtonWidth, ...
                                buttonHeight, ...
                                withinPanelRightPadWidth )
                            
            % Define constants     
            nDOs = length(self.DOChannelNameEdits) ;            
            rowToRowHeight = rowHeight + interRowHeight ;

            % Position the DOs panel
            panelXOffset = panelBorderSize + aiPanelWidth + interPanelSpaceWidth ;
            set(self.DOsPanel, 'Position', [panelXOffset ...
                                            panelBorderSize ...
                                            doPanelWidth ...
                                            digitalPanelsHeight]) ;
            
            %
            %  Layout the row of column titles in DO panel
            %
            titleRowBottomY = digitalPanelsHeight - panelToTitleRowSpaceHeight - titleRowHeight ;
            
            % Channel Name
            channelNameColLeftX = panelToChannelNameColSpaceWidth ;
            ws.alignTextInRectangleBang(self.DOChannelNameColTitleText, ...
                                                [channelNameColLeftX titleRowBottomY channelNameEditWidth titleRowHeight], ...
                                                'cm');
            
            % Channel Terminal Name                                            
            terminalNameColLeftX = channelNameColLeftX + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
            ws.alignTextInRectangleBang(self.DOTerminalNameColTitleText, ...
                                                [terminalNameColLeftX titleRowBottomY terminalNamePopupWidth titleRowHeight], ...
                                                'cm');
                                            
%             % Channel Units
%             unitsColLeftX = terminalNameColLeftX + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
%             ws.alignTextInRectangleBang(self.DOUnitsColTitleText, ...
%                                                 [unitsColLeftX titleRowBottomY unitsEditWidth titleRowHeight], ...
%                                                 'cm');
            
            % Channel Scale Factor
            %scaleColLeftX = unitsColLeftX + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
%             ws.alignTextInRectangleBang(self.DOScaleColTitleText, ...
%                                                 [scaleColLeftX titleRowBottomY scaleEditWidth titleRowHeight], ...
%                                                 'cm');
            
            % Timed?                                
            isTimedColLeftX = doPanelWidth - ( isTimedColWidth + isOnColWidth + isMarkedForDeletionColWidth + withinPanelRightPadWidth ) ;
            ws.alignTextInRectangleBang(self.DOIsTimedColTitleText, [isTimedColLeftX titleRowBottomY isTimedColWidth titleRowHeight], 'cm');
            
            % On?                                
            isOnColLeftX = doPanelWidth - ( isOnColWidth + isMarkedForDeletionColWidth + withinPanelRightPadWidth ) ;
            ws.alignTextInRectangleBang(self.DOIsOnColTitleText, [isOnColLeftX titleRowBottomY isOnColWidth titleRowHeight], 'cm');
            
            % Delete?
            isMarkedForDeletionColLeftX = doPanelWidth - ( isMarkedForDeletionColWidth + withinPanelRightPadWidth ) ;
            ws.alignTextInRectangleBang(self.DOIsMarkedForDeletionColTitleText, ...
                                                [isMarkedForDeletionColLeftX titleRowBottomY isMarkedForDeletionColWidth titleRowHeight], ...
                                                'cm');
            
            % Position the stuff in the DO rows            
            yRowBottom=titleRowBottomY-spaceBelowTitleRowHeight-rowHeight;   
            for i=1:nDOs ,
                % channel name
                %xColLeft=panelToChannelNameColSpaceWidth;
                set(self.DOChannelNameEdits(i), ...
                    'Position',[channelNameColLeftX yRowBottom-editShimHeight channelNameEditWidth editHeight]);  % shim to make look nice
                % terminal name
                %xColLeft = xColLeft + channelNameEditWidth + spaceBetweenChannelNameAndTerminalNameWidth ;
                set(self.DOTerminalNamePopups(i), ...
                    'Position',[terminalNameColLeftX yRowBottom terminalNamePopupWidth rowHeight]);  % shim to make look nice
                % units
                %xColLeft = xColLeft + terminalNamePopupWidth + spaceBetweenTerminalAndRestWidth ;
                %set(self.DOUnitsEdits(i), ...
                %    'Position',[xColLeft diYRowBottom-editShimHeight unitsEditWidth editHeight] );
                % scale
                %xColLeft = xColLeft + unitsEditWidth + spaceBetweenUnitsAndScaleWidth ;
                %set(self.DOScaleEdits(i), ...
                %    'Position',[xColLeft diYRowBottom-editShimHeight scaleEditWidth editHeight]);
                % scale units
                %xColLeft = xColLeft + scaleEditWidth + spaceBetweenScaleAndScaleUnitsWidth ;
                %set(self.DOScaleUnitsTexts(i), ...
                %    'Position',[xColLeft diYRowBottom-4 scaleUnitsTextWidth labelHeight]);
                % timed?
                %xColLeft = isTimedColLeftX ;
                ws.centerCheckboxBang(self.DOIsTimedCheckboxes(i),[isTimedColLeftX+isTimedColWidth/2 yRowBottom+rowHeight/2]);
                % on?
                %xColLeft = xColLeft + isTimedColWidth + spaceBetweenScaleUnitsAndCheckboxColsWidth ;
                ws.centerCheckboxBang(self.DOIsOnRadiobuttons(i),[isOnColLeftX+isOnColWidth/2 yRowBottom+rowHeight/2]);
                % delete?
                %xColLeft = xColLeft + isOnColWidth + spaceBeforeIsMarkedForDeletionColWidth ;
                ws.centerCheckboxBang(self.DOIsMarkedForDeletionCheckboxes(i),[isMarkedForDeletionColLeftX+isMarkedForDeletionColWidth/2 yRowBottom+rowHeight/2]);                
                
                % Prepare for next iteration
                yRowBottom=yRowBottom-rowToRowHeight;
            end
            
            % Position the DO Panel buttons
            buttonYOffset = buttonsToFrameSpaceHeight ;
            
            deleteButtonXOffset = doPanelWidth - panelBorderSize - extraSpaceFromDeleteButtonToBorder - deleteButtonWidth ;  % delete button is flush right
            deleteButtonYOffset = buttonYOffset ;
            deleteButtonHeight = buttonHeight ;
            set(self.DeleteDOChannelsButton, ...
                'Position',[deleteButtonXOffset deleteButtonYOffset deleteButtonWidth deleteButtonHeight]) ;
            
            addButtonXOffset = deleteButtonXOffset - spaceBetweenButtonsWidth - addButtonWidth ;  % add button is to left of delete button
            addButtonYOffset = buttonYOffset ;
            addButtonHeight = buttonHeight ;
            set(self.AddDOChannelButton, ...
                'Position',[addButtonXOffset addButtonYOffset addButtonWidth addButtonHeight]) ;
        end  % function
        
%         function layoutDOPanel_(self, ...
%                                 panelBorderSize, ...
%                                 aiPanelWidth, ...
%                                 interPanelSpaceWidth, ...
%                                 aoPanelWidth, ...
%                                 digitalPanelsHeight, ...
%                                 panelToTitleRowSpaceHeight, ...
%                                 titleRowHeight, ...
%                                 panelToChannelNameColSpaceWidth, ...
%                                 spaceBelowTitleRowHeight, ...
%                                 rowHeight, ...
%                                 interRowHeight, ...
%                                 outputLabelWidth, ...
%                                 spaceBetweenTerminalAndRestWidth, ...
%                                 aoScaleAndUnitsControlsWidth)
%                             
%             % Define constants     
%             nDOs = length(self.DOLabelTexts) ;            
%             %spaceBetweenTerminalAndRestWidth = 6 ;
%             isTimedColWidth = 50 ;
%             spaceBetweenTimedAndIsOnColsWidth = 0 ;
%             isOnColWidth = 30 ;
%             isTimedAndIsOnColCompositeWidth = isTimedColWidth + spaceBetweenTimedAndIsOnColsWidth + isOnColWidth ;
%             spaceToCenterIsTimedAndIsOnColCompositeWidth = (aoScaleAndUnitsControlsWidth-isTimedAndIsOnColCompositeWidth)/2;
%               % the isTimed and isOn columns, together with the fixed space
%               % between them, are treated as a unit, and are centered
%               % withing the space for them, which is the width of 
%               % aoScaleAndUnitsControlsWidth
%             rowToRowHeight=rowHeight+interRowHeight;
% 
%             % Position the DOs panel
%             panelWidth=aoPanelWidth;
%             set(self.DOsPanel,'Position',[panelBorderSize+aiPanelWidth+interPanelSpaceWidth ...
%                                           panelBorderSize ...
%                                           panelWidth ...
%                                           digitalPanelsHeight]);
%             
%             %  Layout the row of column titles in DO panel
%             titleRowBottomY=digitalPanelsHeight-panelToTitleRowSpaceHeight-titleRowHeight;
%             channelLabelColLeftX = panelToChannelNameColSpaceWidth;
%             isTimedColLeftX=channelLabelColLeftX+outputLabelWidth+spaceBetweenTerminalAndRestWidth+spaceToCenterIsTimedAndIsOnColCompositeWidth;
%             ws.alignTextInRectangleBang(self.DOIsTimedColTitleText,[isTimedColLeftX titleRowBottomY isTimedColWidth titleRowHeight],'cm');
%             isOnColLeftX=isTimedColLeftX+isTimedColWidth+spaceBetweenTimedAndIsOnColsWidth;
%             ws.alignTextInRectangleBang(self.DOIsOnColTitleText,[isOnColLeftX titleRowBottomY isOnColWidth titleRowHeight],'cm');
%             
%             % Position the stuff in the DO rows            
%             doYRowBottom=titleRowBottomY-spaceBelowTitleRowHeight-rowHeight;   
%             for i=1:nDOs ,
%                 set(self.DOLabelTexts(i), ...
%                     'Position',[channelLabelColLeftX doYRowBottom-4 outputLabelWidth rowHeight]);  % shim to make look nice
%                 ws.centerCheckboxBang(self.DOIsTimedCheckboxes(i),[isTimedColLeftX+isTimedColWidth/2 doYRowBottom+rowHeight/2]);
%                 ws.centerCheckboxBang(self.DOIsOnRadiobuttons(i),[isOnColLeftX+isOnColWidth/2 doYRowBottom+rowHeight/2]);
%                 doYRowBottom=doYRowBottom-rowToRowHeight;
%             end
%         end  % function
        
        function updateImplementation_(self)
            % This method should make sure the figure is fully synched with the
            % model state after it is called.  This includes existance,
            % placement, sizing, enablement, and properties of each control, and
            % of the figure itself.

            % This implementation should work in most cases, but can be overridden by
            % subclasses if needed.
            self.updateControlsInExistance_();
            self.updateControlPropertiesImplementation_();
            %self.updateControlEnablementImplementation_();
            %  we update the enablement in updateControlPropertiesImplementation_
            self.layout_();
        end
        
%         function updateImplementation_(self,varargin)
%             % Syncs self with model, making no prior assumptions about what
%             % might have changed or not changed in the model.
%             self.updateControlsInExistance_();
%             self.updateControlProperties_();
%             % self.updateControlEnablementImplementation_();  % we do this
%             % in updateControlProperties_
%             self.layout_();
%         end        

        function updateControlPropertiesImplementation_(self,varargin)
            %import ws.*
            model=self.Model;
            if isempty(model) || ~isvalid(model) ,
                return
            end
            
            % Specify colors
            normalBackgroundColor = ws.WavesurferMainFigure.NormalBackgroundColor ;
            warningBackgroundColor = ws.WavesurferMainFigure.WarningBackgroundColor ;            
            
            % Update the device name popup
            allDeviceNames = model.AllDeviceNames ;
            ws.setPopupMenuItemsAndSelectionBang(self.DeviceNamePopup, allDeviceNames, model.DeviceName) ;
            
            % update the panels
            self.updateAIPanelControlPropertiesImplementation_(normalBackgroundColor, warningBackgroundColor) ;
            self.updateAOPanelControlPropertiesImplementation_(normalBackgroundColor, warningBackgroundColor) ;
            self.updateDIPanelControlPropertiesImplementation_(normalBackgroundColor, warningBackgroundColor) ;
            self.updateDOPanelControlPropertiesImplementation_(normalBackgroundColor, warningBackgroundColor) ;            
        end  % function        
        
        function updateAIPanelControlPropertiesImplementation_(self, normalBackgroundColor, warningBackgroundColor)            
            % update the AIs
            model=self.Model;
            isWavesurferIdle=isequal(model.State,'idle');

            %deviceNames=model.Acquisition.AnalogDeviceNames;  % cell array of strings
            terminalNameForEachChannel = model.Acquisition.AnalogTerminalNames ;
            allAITerminalNames = model.getAllAITerminalNames() ;
            %terminalIDs=model.Acquisition.AnalogTerminalIDs;  % zero-based NI channel index
            channelNames=model.Acquisition.AnalogChannelNames;
            channelScales=model.Acquisition.AnalogChannelScales;
            channelUnits=model.Acquisition.AnalogChannelUnits;
            nElectrodesClaimingChannel=model.Acquisition.getNumberOfElectrodesClaimingAnalogChannel();
            isChannelScaleEnslaved=(nElectrodesClaimingChannel>=1);
            %isChannelOvercommitted=(nElectrodesClaimingChannel>1);
            isTerminalOvercommitted = model.IsAIChannelTerminalOvercommitted ;
            nAIs=length(self.AIScaleEdits);            
            for i=1:nAIs ,
                set(self.AIChannelNameEdits(i), 'String', channelNames{i} );                
                ws.setPopupMenuItemsAndSelectionBang(self.AITerminalNamePopups(i), ...
                                                             allAITerminalNames, ...
                                                             terminalNameForEachChannel{i});
                set(self.AITerminalNamePopups(i) , ...
                    'BackgroundColor',ws.fif(isTerminalOvercommitted(i),warningBackgroundColor,normalBackgroundColor) ) ;
                set(self.AIUnitsEdits(i),'String',channelUnits{i}, ...
                                         'Enable',ws.onIff(isWavesurferIdle&&~isChannelScaleEnslaved(i)));
                set(self.AIScaleEdits(i),'String',sprintf('%g',channelScales(i)), ...
                                         'Enable',ws.onIff(isWavesurferIdle&&~isChannelScaleEnslaved(i)));
                set(self.AIScaleUnitsTexts(i),'String',sprintf('V/%s',channelUnits{i})) ;
                set(self.AIIsActiveCheckboxes(i),'Value',self.Model.Acquisition.IsAnalogChannelActive(i), ...
                                                 'Enable',ws.onIff(isWavesurferIdle));                                     
                set(self.AIIsMarkedForDeletionCheckboxes(i),'Value',self.Model.Acquisition.IsAnalogChannelMarkedForDeletion(i), ...
                                                            'Enable',ws.onIff(isWavesurferIdle));                                     
            end            
            
            % Deal with enablement of add/delete buttons
            nAITerminals = model.NAITerminals ;   
            areAnyFreeAITerminals =  (nAIs<nAITerminals) ;
            isAIChannelMarkedForDeletion = model.Acquisition.IsAnalogChannelMarkedForDeletion ;
            isAnyAIChannelMarkedForDeletion = any(isAIChannelMarkedForDeletion) ;
            set(self.AddAIChannelButton, 'Enable', ws.onIff(isWavesurferIdle && areAnyFreeAITerminals)) ;
            set(self.DeleteAIChannelsButton, 'Enable', ws.onIff(isWavesurferIdle && isAnyAIChannelMarkedForDeletion)) ;
        end  % function        
        
        function updateAOPanelControlPropertiesImplementation_(self, normalBackgroundColor, warningBackgroundColor)            
            % update the AOs
            model=self.Model;
            isWavesurferIdle=isequal(model.State,'idle');

            %deviceNames=model.Stimulation.AnalogDeviceNames;  % cell array of strings
            terminalNameForEachChannel = model.Stimulation.AnalogTerminalNames ;
            allAOTerminalNames = model.getAllAOTerminalNames() ;
            %terminalIDs=model.Stimulation.AnalogTerminalIDs;  % zero-based NI channel index
            channelNames=model.Stimulation.AnalogChannelNames;
            channelScales=model.Stimulation.AnalogChannelScales;
            channelUnits=model.Stimulation.AnalogChannelUnits;
            nElectrodesClaimingChannel=model.Stimulation.getNumberOfElectrodesClaimingAnalogChannel();
            isChannelScaleEnslaved=(nElectrodesClaimingChannel>=1);
            %isChannelOvercommitted=(nElectrodesClaimingChannel>1);
            isTerminalOvercommitted = model.IsAOChannelTerminalOvercommitted ;
            nAOChannels=length(self.AOChannelNameEdits);            
            for i=1:nAOChannels ,
                set(self.AOChannelNameEdits(i), 'String', channelNames{i} );                
                ws.setPopupMenuItemsAndSelectionBang(self.AOTerminalNamePopups(i), ...
                                                             allAOTerminalNames, ...
                                                             terminalNameForEachChannel{i});
                set(self.AOTerminalNamePopups(i) , ...
                    'BackgroundColor',ws.fif(isTerminalOvercommitted(i),warningBackgroundColor,normalBackgroundColor) ) ;
                set(self.AOUnitsEdits(i),'String',channelUnits{i}, ...
                                         'Enable',ws.onIff(isWavesurferIdle&&~isChannelScaleEnslaved(i)));
                set(self.AOScaleEdits(i),'String',sprintf('%g',channelScales(i)), ...
                                         'Enable',ws.onIff(isWavesurferIdle&&~isChannelScaleEnslaved(i)));
                set(self.AOScaleUnitsTexts(i),'String',sprintf('V/%s',channelUnits{i})) ;
                %set(self.AOIsActiveCheckboxes(i),'Value',self.Model.Stimulation.IsAnalogChannelActive(i), ...
                %                                 'Enable',onIff(isWavesurferIdle));                                     
                set(self.AOIsMarkedForDeletionCheckboxes(i),'Value',self.Model.Stimulation.IsAnalogChannelMarkedForDeletion(i), ...
                                                            'Enable',ws.onIff(isWavesurferIdle));                                     
            end
            
            % Deal with enablement of add/delete buttons
            nAOTerminals = model.NAOTerminals ;   
            areAnyFreeAOTerminals =  (nAOChannels<nAOTerminals) ;
            isAOChannelMarkedForDeletion = model.Stimulation.IsAnalogChannelMarkedForDeletion ;
            isAnyAOChannelMarkedForDeletion = any(isAOChannelMarkedForDeletion) ;
            set(self.AddAOChannelButton, 'Enable', ws.onIff(isWavesurferIdle && areAnyFreeAOTerminals)) ;
            set(self.DeleteAOChannelsButton, 'Enable', ws.onIff(isWavesurferIdle && isAnyAOChannelMarkedForDeletion)) ;
        end  % function
        
        function updateDIPanelControlPropertiesImplementation_(self, normalBackgroundColor, warningBackgroundColor)
            % update the DIs
            model=self.Model;
            isWavesurferIdle=isequal(model.State,'idle');

            %deviceNames=model.Acquisition.AnalogDeviceNames;  % cell array of strings
            terminalNameForEachChannel = model.Acquisition.DigitalTerminalNames ;
            allTerminalNames = model.getAllDigitalTerminalNames() ;
            channelNames=model.Acquisition.DigitalChannelNames;
            isTerminalOvercommitted = model.IsDIChannelTerminalOvercommitted ;
            nDIChannels=length(self.DIChannelNameEdits);            
            for i=1:nDIChannels ,
                set(self.DIChannelNameEdits(i), 'String', channelNames{i} );
                ws.setPopupMenuItemsAndSelectionBang(self.DITerminalNamePopups(i), ...
                                                             allTerminalNames, ...
                                                             terminalNameForEachChannel{i});
                set(self.DITerminalNamePopups(i) , ...
                    'BackgroundColor',ws.fif(isTerminalOvercommitted(i),warningBackgroundColor,normalBackgroundColor) ) ;
                set(self.DIIsActiveCheckboxes(i),'Value',self.Model.Acquisition.IsDigitalChannelActive(i), ...
                                                 'Enable',ws.onIff(isWavesurferIdle));                                     
                set(self.DIIsMarkedForDeletionCheckboxes(i),'Value',self.Model.Acquisition.IsDigitalChannelMarkedForDeletion(i), ...
                                                            'Enable',ws.onIff(isWavesurferIdle));                                     
            end            
            
            % Deal with enablement of add/delete buttons
            nDIOTerminals = model.NDIOTerminals ;   
            nDigitalChannels = model.NDigitalChannels ;
            areFewerDigitalChannelsThanDIOTerminals =  (nDigitalChannels<nDIOTerminals) ;
            %areAnyFreeDIOTerminals =  ~isempty(model.freeDigitalTerminalIDs()) ;
            isDIChannelMarkedForDeletion = model.Acquisition.IsDigitalChannelMarkedForDeletion ;
            isAnyDIChannelMarkedForDeletion = any(isDIChannelMarkedForDeletion) ;
            set(self.AddDIChannelButton, 'Enable', ws.onIff(isWavesurferIdle && areFewerDigitalChannelsThanDIOTerminals)) ;
            set(self.DeleteDIChannelsButton, 'Enable', ws.onIff(isWavesurferIdle && isAnyDIChannelMarkedForDeletion)) ;            
        end  % function        
       
        function updateDOPanelControlPropertiesImplementation_(self, normalBackgroundColor, warningBackgroundColor)
            % update the DIs
            model=self.Model;
            isWavesurferIdle=isequal(model.State,'idle');

            %deviceNames=model.Acquisition.AnalogDeviceNames;  % cell array of strings
            terminalNameForEachChannel = model.Stimulation.DigitalTerminalNames ;
            allTerminalNames = model.getAllDigitalTerminalNames() ;
            channelNames=model.Stimulation.DigitalChannelNames;
            isTimed = model.Stimulation.IsDigitalChannelTimed ;
            isTerminalOvercommitted = model.IsDOChannelTerminalOvercommitted ;
            nDOs=length(self.DOChannelNameEdits);            
            for i=1:nDOs ,
                set(self.DOChannelNameEdits(i), 'String', channelNames{i} );
                ws.setPopupMenuItemsAndSelectionBang(self.DOTerminalNamePopups(i), ...
                                                             allTerminalNames, ...
                                                             terminalNameForEachChannel{i});
                set(self.DOTerminalNamePopups(i) , ...
                    'BackgroundColor',ws.fif(isTerminalOvercommitted(i),warningBackgroundColor,normalBackgroundColor) ) ;
                set(self.DOIsTimedCheckboxes(i),'value',self.Model.Stimulation.IsDigitalChannelTimed(i),...
                                                'enable',ws.onIff(isWavesurferIdle));
                set(self.DOIsOnRadiobuttons(i),'value',self.Model.Stimulation.DigitalOutputStateIfUntimed(i),...
                                               'enable',ws.onIff(~isTimed(i)));
                set(self.DOIsMarkedForDeletionCheckboxes(i),'Value',self.Model.Stimulation.IsDigitalChannelMarkedForDeletion(i), ...
                                                            'Enable',ws.onIff(isWavesurferIdle));                                     
            end            
            
            % Deal with enablement of add/delete buttons
            nDIOTerminals = model.NDIOTerminals ;   
            nDigitalChannels = model.NDigitalChannels ;
            areFewerDigitalChannelsThanDIOTerminals =  (nDigitalChannels<nDIOTerminals) ;            
            %areAnyFreeDIOTerminals =  ~isempty(model.freeDigitalTerminalIDs()) ;
            isDOChannelMarkedForDeletion = model.Stimulation.IsDigitalChannelMarkedForDeletion ;
            isAnyDOChannelMarkedForDeletion = any(isDOChannelMarkedForDeletion) ;
            set(self.AddDOChannelButton, 'Enable', ws.onIff(isWavesurferIdle && areFewerDigitalChannelsThanDIOTerminals) ) ;
            set(self.DeleteDOChannelsButton, 'Enable', ws.onIff(isWavesurferIdle && isAnyDOChannelMarkedForDeletion) ) ;                        
        end  % function        
       
%         function updateDOPanelControlPropertiesImplementation_(self, normalBackgroundColor, warningBackgroundColor)  %#ok<INUSD>
%             % update the DOs
%             model=self.Model;
%             isWavesurferIdle=isequal(model.State,'idle');
%             
%             terminalNameForEachChannel = model.Stimulation.DigitalTerminalNames ;
%             channelNames=model.Stimulation.DigitalChannelNames;
%             isTimed=model.Stimulation.IsDigitalChannelTimed;
%             nDOs = length(self.DOLabelTexts) ;
%             for i=1:nDOs ,
%                 set(self.DOLabelTexts(i),'String',sprintf('%s (%s):',channelNames{i}, terminalNameForEachChannel{i}));                
%                 set(self.DOIsTimedCheckboxes(i),'value',self.Model.Stimulation.IsDigitalChannelTimed(i),...
%                                                 'enable',ws.onIff(isWavesurferIdle));
%                 set(self.DOIsOnRadiobuttons(i),'value',self.Model.Stimulation.DigitalOutputStateIfUntimed(i),...
%                                                'enable',ws.onIff(~isTimed(i)));
%             end            
%         end        
        
    end  % protected methods block
    
    methods (Access = protected)
        function updateControlsInExistance_(self)
            % In subclass, this should make sure the non-fixed controls in
            % existance are synced with the model state, deleting
            % inappropriate ones and creating appropriate ones as needed.            
            
            self.updateAIPanelControlsInExistance_() ;
            self.updateAOPanelControlsInExistance_() ;
            self.updateDIPanelControlsInExistance_() ;
            self.updateDOPanelControlsInExistance_() ;
        end  % function
        
        function updateAIPanelControlsInExistance_(self)
            model = self.Model ;
            if isempty(model) ,
                nAIs = 0 ;
            else
                nAIs = model.Acquisition.NAnalogChannels ;
            end
            
            % Redimension AI arrays as needed
            nAIsBefore = length(self.AIChannelNameEdits) ;
            if nAIsBefore<nAIs ,
                % need to make more slots, fill them
                
                % redimension arrays
                self.AIChannelNameEdits(nAIs) = 0 ;
                self.AITerminalNamePopups(nAIs) = 0 ;
                self.AIScaleEdits(nAIs)= 0 ;
                self.AIScaleUnitsTexts(nAIs)= 0 ;
                self.AIUnitsEdits(nAIs)= 0 ;
                self.AIIsActiveCheckboxes(nAIs)= 0 ;                
                self.AIIsMarkedForDeletionCheckboxes(nAIs)= 0 ;                
                
                % Populate the AI channel rows      
                for i=(nAIsBefore+1):nAIs ,
                    self.AIChannelNameEdits(i)= ...
                        ws.uiedit('Parent',self.AIsPanel, ...
                                  'Tag',sprintf('AIChannelNameEdits%d',i), ...
                                  'HorizontalAlignment','left', ...
                                  'Callback',@(source,event)(self.controlActuated('AIChannelNameEdits',source,event)) );
                    self.AITerminalNamePopups(i)= ...
                        ws.uicontrol('Parent',self.AIsPanel, ...
                                  'Style','popup', ...
                                  'Tag',sprintf('AITerminalNamePopups%d',i), ...
                                  'BackgroundColor','w', ...
                                  'HorizontalAlignment','right', ...
                                  'Callback',@(source,event)(self.controlActuated('AITerminalNamePopups',source,event)) );
                    self.AIScaleEdits(i)= ...
                        ws.uiedit('Parent',self.AIsPanel, ...
                                  'Tag',sprintf('AIScaleEdits%d',i), ...
                                  'HorizontalAlignment','right', ...
                                  'Callback',@(source,event)(self.controlActuated('AIScaleEdits',source,event)) );
                    self.AIScaleUnitsTexts(i)= ...
                        ws.uicontrol('Parent',self.AIsPanel, ...
                                  'Style','text', ...
                                  'Tag',sprintf('AIScaleUnitsTexts%d',i), ...
                                  'String','V/V', ...
                                  'HorizontalAlignment','left');
                    self.AIUnitsEdits(i)= ...
                        ws.uiedit('Parent',self.AIsPanel, ...
                                  'Tag',sprintf('AIUnitsEdits%d',i), ...
                                  'HorizontalAlignment','left', ...
                                  'Callback',@(source,event)(self.controlActuated('AIUnitsEdits',source,event)) );
                    self.AIIsActiveCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.AIsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('AIIsActiveCheckboxes',source,event)));                          
                    self.AIIsMarkedForDeletionCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.AIsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('AIIsMarkedForDeletionCheckboxes',source,event)));
                end                
            elseif nAIsBefore>nAIs 
                % delete the objects
                delete(self.AIChannelNameEdits(nAIs+1:end)) ;
                delete(self.AITerminalNamePopups(nAIs+1:end)) ;                
                delete(self.AIScaleEdits(nAIs+1:end)) ;
                delete(self.AIScaleUnitsTexts(nAIs+1:end)) ;
                delete(self.AIUnitsEdits(nAIs+1:end)) ;
                delete(self.AIIsActiveCheckboxes(nAIs+1:end)) ;                
                delete(self.AIIsMarkedForDeletionCheckboxes(nAIs+1:end)) ;                
                
                % need to trim the arrays
                self.AIChannelNameEdits(nAIs+1:end) = [] ;
                self.AITerminalNamePopups(nAIs+1:end) = [] ;
                self.AIScaleEdits(nAIs+1:end) = [] ;
                self.AIScaleUnitsTexts(nAIs+1:end) = [] ;
                self.AIUnitsEdits(nAIs+1:end) = [] ;
                self.AIIsActiveCheckboxes(nAIs+1:end) = [] ;                
                self.AIIsMarkedForDeletionCheckboxes(nAIs+1:end) = [] ;                
            end
        end  % function
        
        function updateAOPanelControlsInExistance_(self)
            model = self.Model ;
            if isempty(model) ,
                nAOs = 0 ;
            else
                nAOs = model.Stimulation.NAnalogChannels ;
            end
            
            % Redimension AO arrays as needed
            nAOsBefore = length(self.AOChannelNameEdits) ;
            if nAOsBefore<nAOs ,
                % need to make more slots, fill them
                
                % redimension arrays
                self.AOChannelNameEdits(nAOs) = 0 ;
                self.AOTerminalNamePopups(nAOs) = 0 ;
                self.AOScaleEdits(nAOs)= 0 ;
                self.AOScaleUnitsTexts(nAOs)= 0 ;
                self.AOUnitsEdits(nAOs)= 0 ;
                %self.AOIsActiveCheckboxes(nAOs)= 0 ;                
                self.AOIsMarkedForDeletionCheckboxes(nAOs)= 0 ;                
                
                % Populate the AO channel rows      
                for i=(nAOsBefore+1):nAOs ,
                    self.AOChannelNameEdits(i)= ...
                        ws.uiedit('Parent',self.AOsPanel, ...
                                  'Tag',sprintf('AOChannelNameEdits%d',i), ...
                                  'HorizontalAlignment','left', ...
                                  'Callback',@(source,event)(self.controlActuated('AOChannelNameEdits',source,event)) );
                    self.AOTerminalNamePopups(i)= ...
                        ws.uicontrol('Parent',self.AOsPanel, ...
                                  'Style','popup', ...
                                  'Tag',sprintf('AOTerminalNamePopups%d',i), ...
                                  'BackgroundColor','w', ...
                                  'HorizontalAlignment','right', ...
                                  'Callback',@(source,event)(self.controlActuated('AOTerminalNamePopups',source,event)) );
                    self.AOScaleEdits(i)= ...
                        ws.uiedit('Parent',self.AOsPanel, ...
                                  'Tag',sprintf('AOScaleEdits%d',i), ...
                                  'HorizontalAlignment','right', ...
                                  'Callback',@(source,event)(self.controlActuated('AOScaleEdits',source,event)) );
                    self.AOScaleUnitsTexts(i)= ...
                        ws.uicontrol('Parent',self.AOsPanel, ...
                                  'Style','text', ...
                                  'Tag',sprintf('AOScaleUnitsTexts%d',i), ...
                                  'String','V/V', ...
                                  'HorizontalAlignment','left');
                    self.AOUnitsEdits(i)= ...
                        ws.uiedit('Parent',self.AOsPanel, ...
                                  'Tag',sprintf('AOUnitsEdits%d',i), ...
                                  'HorizontalAlignment','left', ...
                                  'Callback',@(source,event)(self.controlActuated('AOUnitsEdits',source,event)) );
%                     self.AOIsActiveCheckboxes(i)= ...
%                         ws.uicontrol('Parent',self.AOsPanel, ...
%                                   'Style','checkbox', ...
%                                   'Value',0, ...
%                                   'String','', ...
%                                   'Callback',@(source,event)(self.controlActuated('AOIsActiveCheckboxes',source,event)));                          
                    self.AOIsMarkedForDeletionCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.AOsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('AOIsMarkedForDeletionCheckboxes',source,event)));
                end                
            elseif nAOsBefore>nAOs 
                % delete the objects
                delete(self.AOChannelNameEdits(nAOs+1:end)) ;
                delete(self.AOTerminalNamePopups(nAOs+1:end)) ;                
                delete(self.AOScaleEdits(nAOs+1:end)) ;
                delete(self.AOScaleUnitsTexts(nAOs+1:end)) ;
                delete(self.AOUnitsEdits(nAOs+1:end)) ;
                %delete(self.AOIsActiveCheckboxes(nAOs+1:end)) ;                
                delete(self.AOIsMarkedForDeletionCheckboxes(nAOs+1:end)) ;                
                
                % need to trim the arrays
                self.AOChannelNameEdits(nAOs+1:end) = [] ;
                self.AOTerminalNamePopups(nAOs+1:end) = [] ;
                self.AOScaleEdits(nAOs+1:end) = [] ;
                self.AOScaleUnitsTexts(nAOs+1:end) = [] ;
                self.AOUnitsEdits(nAOs+1:end) = [] ;
                %self.AOIsActiveCheckboxes(nAOs+1:end) = [] ;                
                self.AOIsMarkedForDeletionCheckboxes(nAOs+1:end) = [] ;                
            end
        end  % function
        
        function updateDIPanelControlsInExistance_(self)
            model = self.Model ;
            if isempty(model) ,
                nDIs = 0 ;
            else
                nDIs = model.Acquisition.NDigitalChannels ;
            end
            
            % Redimension DI arrays as needed
            nDIsBefore = length(self.DIChannelNameEdits) ;
            if nDIsBefore<nDIs ,
                % need to make more slots, fill them
                
                % redimension arrays
                self.DIChannelNameEdits(nDIs) = 0 ;
                self.DITerminalNamePopups(nDIs) = 0 ;
                self.DIIsActiveCheckboxes(nDIs)= 0 ;                
                self.DIIsMarkedForDeletionCheckboxes(nDIs)= 0 ;                
                
                % Populate the DI channel rows      
                for i=(nDIsBefore+1):nDIs ,
                    self.DIChannelNameEdits(i)= ...
                        ws.uiedit('Parent',self.DIsPanel, ...
                                  'Tag',sprintf('DIChannelNameEdits%d',i), ...
                                  'HorizontalAlignment','left', ...
                                  'Callback',@(source,event)(self.controlActuated('DIChannelNameEdits',source,event)) );
                    self.DITerminalNamePopups(i)= ...
                        ws.uicontrol('Parent',self.DIsPanel, ...
                                  'Style','popup', ...
                                  'Tag',sprintf('DITerminalNamePopups%d',i), ...
                                  'BackgroundColor','w', ...
                                  'HorizontalAlignment','right', ...
                                  'Callback',@(source,event)(self.controlActuated('DITerminalNamePopups',source,event)) );
                    self.DIIsActiveCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.DIsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('DIIsActiveCheckboxes',source,event)));                          
                    self.DIIsMarkedForDeletionCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.DIsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('DIIsMarkedForDeletionCheckboxes',source,event)));
                end                
            elseif nDIsBefore>nDIs 
                % delete the objects
                delete(self.DIChannelNameEdits(nDIs+1:end)) ;
                delete(self.DITerminalNamePopups(nDIs+1:end)) ;                
                delete(self.DIIsActiveCheckboxes(nDIs+1:end)) ;                
                delete(self.DIIsMarkedForDeletionCheckboxes(nDIs+1:end)) ;                
                
                % need to trim the arrays
                self.DIChannelNameEdits(nDIs+1:end) = [] ;
                self.DITerminalNamePopups(nDIs+1:end) = [] ;
                self.DIIsActiveCheckboxes(nDIs+1:end) = [] ;                
                self.DIIsMarkedForDeletionCheckboxes(nDIs+1:end) = [] ;                
            end
        end  % function
        
        function updateDOPanelControlsInExistance_(self)
            model = self.Model ;
            if isempty(model) ,
                nDOs = 0 ;
            else
                nDOs = model.Stimulation.NDigitalChannels ;
            end
            
            % Redimension DO arrays as needed
            nDOsBefore = length(self.DOChannelNameEdits) ;
            if nDOsBefore<nDOs ,
                % need to make more slots, fill them
                
                % redimension arrays
                self.DOChannelNameEdits(nDOs) = 0 ;
                self.DOTerminalNamePopups(nDOs) = 0 ;
                self.DOIsTimedCheckboxes(nDOs)= 0 ;                
                self.DOIsOnRadiobuttons(nDOs)= 0 ;                
                self.DOIsMarkedForDeletionCheckboxes(nDOs)= 0 ;                
                
                % Populate the DO channel rows      
                for i=(nDOsBefore+1):nDOs ,
                    self.DOChannelNameEdits(i)= ...
                        ws.uiedit('Parent',self.DOsPanel, ...
                                  'Tag',sprintf('DOChannelNameEdits%d',i), ...
                                  'HorizontalAlignment','left', ...
                                  'Callback',@(source,event)(self.controlActuated('DOChannelNameEdits',source,event)) );
                    self.DOTerminalNamePopups(i)= ...
                        ws.uicontrol('Parent',self.DOsPanel, ...
                                  'Style','popup', ...
                                  'Tag',sprintf('DOTerminalNamePopups%d',i), ...
                                  'BackgroundColor','w', ...
                                  'HorizontalAlignment','right', ...
                                  'Callback',@(source,event)(self.controlActuated('DOTerminalNamePopups',source,event)) );
                    self.DOIsTimedCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.DOsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('DOIsTimedCheckboxes',source,event)));
                    self.DOIsOnRadiobuttons(i)= ...
                        ws.uicontrol('Parent',self.DOsPanel, ...
                                  'Style','radiobutton', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('DOIsOnRadiobuttons',source,event)));
                    self.DOIsMarkedForDeletionCheckboxes(i)= ...
                        ws.uicontrol('Parent',self.DOsPanel, ...
                                  'Style','checkbox', ...
                                  'Value',0, ...
                                  'String','', ...
                                  'Callback',@(source,event)(self.controlActuated('DOIsMarkedForDeletionCheckboxes',source,event)));
                end                
            elseif nDOsBefore>nDOs 
                % delete the objects
                delete(self.DOChannelNameEdits(nDOs+1:end)) ;
                delete(self.DOTerminalNamePopups(nDOs+1:end)) ;                
                delete(self.DOIsTimedCheckboxes(nDOs+1:end)) ;
                delete(self.DOIsOnRadiobuttons(nDOs+1:end)) ;                

                delete(self.DOIsMarkedForDeletionCheckboxes(nDOs+1:end)) ;                
                
                % need to trim the arrays
                self.DOChannelNameEdits(nDOs+1:end) = [] ;
                self.DOTerminalNamePopups(nDOs+1:end) = [] ;
                self.DOIsTimedCheckboxes(nDOs+1:end) = [] ;                
                self.DOIsOnRadiobuttons(nDOs+1:end) = [] ;                                
                self.DOIsMarkedForDeletionCheckboxes(nDOs+1:end) = [] ;                
            end
        end  % function
                
    end  % protected methods block    
    
end  % classdef
